package com.perforce.workshop.tjuricek.p4oauth;

import org.openqa.selenium.WebDriver;
import org.openqa.selenium.firefox.FirefoxDriver;
import org.openqa.selenium.support.ui.WebDriverWait;

/**
 */
public interface WebdriverTest {

    WebDriver getWebDriver();

    void setWebDriver(WebDriver webDriver);

    default void initWebdriver() {
        if (getWebDriver() == null) {
            // According to http://code.google.com/p/selenium/wiki/UntrustedSSLCertificates
            // firefox is the only browser that accepts untrusted TLS certs
            // by default. Thus, this is the only browser we can use.
            FirefoxDriver webDriver = new FirefoxDriver();
            setWebDriver(webDriver);
        }
    }

    default WebDriverWait getWait() {
        return new WebDriverWait(getWebDriver(), 15);
    }

    default void stopWebDriver() {
        if (getWebDriver() != null) {
            getWebDriver().close();
            setWebDriver(null);
        }
    }
}
